/**
 * \file gre/3dpmgeom.h
 * \brief PINMAP_GEOMETRIC3D definitions.
 *
 * \if NODOC
 * $Id: 3dpmgeom.h_v 1.2 2011/10/20 12:41:37 mju Exp $
 *
 * $Log: 3dpmgeom.h_v $
 * Revision 1.2  2011/10/20 12:41:37  mju
 * Remove redundant hdr.
 *
 * Revision 1.1  2007/06/20 16:01:25  vdronov
 * Initial revision
 * \endif
**/ 

#ifndef	INC_GRE_3DPMGEOM_H
#define	INC_GRE_3DPMGEOM_H

#ifndef	INC_GRE_3DGEOMET_H
#include <gre/3dgeomet.h>
#endif

#ifndef	INC_GRE_LRPINMAP_H
#include <gre/lrpinmap.h>
#endif

#ifndef	INC_RVC_DBTABLE_H
#include <rvc/dbtable.h>
#endif

namespace GRE {

class PINMAP_GEOMETRIC3D : public GEOMETRIC3D {
	public:

		PINMAP_GEOMETRIC3D (			 							  
			);

		virtual ~PINMAP_GEOMETRIC3D (								//! Destructor
			);

		RVC::DBASE GetDatabase () {return m_Database; };
		RVC::DBTABLE& GetTable () {return m_Table; };
		GRE::LAYER_PINMAP* GetPinmapLayer () { return m_Layer; };
		double ComputeScale (const INT32 id);

	private:
		#ifndef GENERATING_DOXYGEN_OUTPUT

		RVC::DBASE m_Database;
		RVC::DBTABLE m_Table;
		GRE::LAYER_PINMAP *m_Layer;
		DRECT3D ALIGN16(m_Extents);
		SPATREF::COORDREFSYS m_CoordRefSys;
		TRANS2D_MAPGEN m_Transformation;

		PINMAP_GEOMETRIC3D (											//! Copy constructor (not implemented)
			const PINMAP_GEOMETRIC3D& rhs
			);

		PINMAP_GEOMETRIC3D& operator= (								//! Assignment operator (not implemented)
			const PINMAP_GEOMETRIC3D& rhs
			);

		ERRVALUE UpdateExtents (
			TRANS2D_MAPGEN& transformation, 
			DRECT3D& extents
            );

		GEOMETRIC3D* v_CreateInstance (
			) { return new PINMAP_GEOMETRIC3D(); };

		ERRVALUE v_Build (
			const GRE::LAYER *layer
			);

		void v_Free (
			);

		const DRECT3D& v_GetExtents (
			) { return m_Extents; };

		void v_SetCoordRefSys (
			const SPATREF::COORDREFSYS& CoordRefSys
			);

		const SPATREF::COORDREFSYS v_GetCoordRefSys (
			) { return m_CoordRefSys; };

		const TRANS2D_MAPGEN& v_GetTransformationInternalToModel (
			) { return m_Transformation; };

		void OnDrawBegin (	GRE::GEOMETRIC3D_BUILDER* builder, const bool wireframe = false);

		void OnDrawEnd ();


		#endif // GENERATING_DOXYGEN_OUTPUT

	};

}		// End of GRE namespace

#endif
