/**
 * \file gre/toolsml.h
 * \brief GRE TOOL_SML class
 *
 * \if NODOC
 * $Id: toolsml.h_v 1.12 2013/02/15 20:49:50 mju Exp $
 *
 * $Log: toolsml.h_v $
 * Revision 1.12  2013/02/15 20:49:50  mju
 * Fix dox hdr.
 *
 * Revision 1.11  2011/10/06 17:53:07  mju
 * *** empty log message ***
 *
 * Revision 1.10  2011/10/06 17:51:49  mju
 * Use viewscript hdr.
 *
 * Revision 1.9  2008/01/25 15:33:57  mju
 * Move toolscriptcontext to viewscript hdr.
 *
 * Revision 1.8  2007/11/05 15:36:14  mju
 * Use viewlegacy hdr.
 *
 * Revision 1.7  2007/09/28 17:38:13  mju
 * Use view_legacy.
 *
 * Revision 1.6  2006/09/21 17:48:28  mju
 * Don't use xdefns
 *
 * Revision 1.5  2005/10/17 20:46:28  mju
 * Use gre namespace.
 *
 * Revision 1.4  2003/09/15 13:48:59  fileserver!dwilliss
 * Doxygen
 *
 * Revision 1.3  2003/07/30 15:38:00  mju
 * Ignore private section.
 *
 * Revision 1.1  2003/06/24 16:24:44  mju
 * Initial revision
 * \endif
**/

#ifndef	INC_GRE_TOOLSML_H
#define	INC_GRE_TOOLSML_H

#ifndef	INC_GRE_VIEWLEGACY_H
	#include <gre/viewlegacy.h>
#endif

#ifndef	INC_GRE_VIEWSCRIPT_H
	#include <gre/viewscript.h>
#endif

namespace GRE {
//===================================================================================================================

#if defined(X_NATIVE)
//! Script Tool class definition.
class TOOL_SML : public GRE::TOOL {
	public:

		TOOL_SML (
			GRE::VIEW_LEGACY *view,
			const GRE::TOOLSCRIPT& script
			);

		virtual ~TOOL_SML ();

		virtual bool IsScript (
			) const;

	private:

		#ifndef GENERATING_DOXYGEN_OUTPUT

		GRE::TOOLSCRIPT m_script;
		GRE::TOOLSCRIPT::CONTEXT *m_context;

		static void EH_DrawingArea (
			Widget,
			TOOL_SML *tool,
			XEvent *event,
			Boolean *
			);

		virtual bool DoActivate ();
		virtual void DoDeactivate ();
		virtual bool DoInitialize ();
		virtual void DoSuspend ();
		virtual void DoResume ();

		TOOL_SML (const TOOL_SML&);
		TOOL_SML& operator= (const TOOL_SML&);

		#endif // GENERATING_DOXYGEN_OUTPUT
	};	// End of TOOL_SML

#endif

//===================================================================================================================
}	// End namespace GRE

#endif	// INC_GRE_TOOLSML_H
