/**
 * \file mgui/appmulti.h
 * \brief Classes for multiple entry-point applications
 *
 * \if NODOC
 * $Id: appmulti.h_v 1.6 2004/02/12 16:19:49 mju Exp $
 *
 * $Log: appmulti.h_v $
 * Revision 1.6  2004/02/12 16:19:49  mju
 * Don't delete app_base instance as is done by app_main.
 * Don't need to keep track of app_base instance pointer.
 *
 * Revision 1.5  2003/10/03 19:58:19  linux32build!build
 * Doxygen
 *
 * Revision 1.4  2003/09/15 16:56:30  dwilliss
 * Fixed mismatched ifdef
 *
 * Revision 1.3  2003/09/15 13:49:32  fileserver!dwilliss
 * Doxygen
 *
 * Revision 1.2  2003/06/12 17:34:54  mju
 * Forgot type on method defn.
 *
 * Revision 1.1  2003/04/23 22:00:17  mju
 * Initial revision
 * \endif
**/

#ifndef	INC_MGUI_APPMULTI_H
#define	INC_MGUI_APPMULTI_H

#ifndef	INC_MGUI_APPMAIN_H
#include <mgui/appmain.h>
#endif

namespace MGUI {

class APP_MULTI_MAIN;

#ifndef GENERATING_DOXYGEN_OUTPUT
class APP_MULTI_AUTOREG {
	public:
		APP_MULTI_AUTOREG (
			const char *CmdParmStr
			) : m_CmdParmStr(CmdParmStr), m_pNext(0) { }
	private:
		#ifndef GENERATING_DOXYGEN_OUTPUT
		const char *m_CmdParmStr;
		APP_MULTI_AUTOREG *m_pNext;
		#endif // GENERATING_DOXYGEN_OUTPUT
		virtual void v_ConstructInstance () = 0;
		#ifndef GENERATING_DOXYGEN_OUTPUT
		friend class APP_MULTI_MAIN;
		#endif // GENERATING_DOXYGEN_OUTPUT
	};

#define	MGUI_APP_MULTI_REGISTER(basetype,parmstr)					\
class basetype##_AUTOREG : public MGUI::APP_MULTI_AUTOREG {		\
	public:																		\
		basetype##_AUTOREG () :												\
			MGUI::APP_MULTI_AUTOREG(parmstr)								\
			{ MGUI::APP_MULTI_MAIN::RegisterApp(this); }				\
	private:																		\
		virtual void v_ConstructInstance ()								\
			{ new basetype ; }												\
																					\
	};																				\
static basetype##_AUTOREG basetype##_AutoReg;						

#endif // GENERATING_DOXYGEN_OUTPUT


class APP_MULTI_MAIN : public APP_MAIN {
	public:

		static void RegisterApp (APP_MULTI_AUTOREG *pAutoRegInstance);

		APP_MULTI_MAIN () {}

		~APP_MULTI_MAIN () {}

	private:
		#ifndef GENERATING_DOXYGEN_OUTPUT
		// Overrides from APP_MAIN.
		virtual bool v_InitInstance ();
		#endif // GENERATING_DOXYGEN_OUTPUT
	};


}	//! End namespace MGUI

#endif	// INC_MGUI_APPMULTI_H
