/**
*	\file <mi32/filepathlist.h>
*	\brief FILEPATHLIST defns
*
*	\if NODOC
*	$Id: filepathlist.h_v 1.2 2009/10/02 20:01:14 mju Exp $
*
*	$Log: filepathlist.h_v $
*	Revision 1.2  2009/10/02 20:01:14  mju
*	Add iniRead/Write.
*
*	Revision 1.1  2007/05/07 20:39:26  mju
*	Initial revision
*
*	\endif
**/

#ifndef	INC_MI32_FILEPATHLIST_H
#define	INC_MI32_FILEPATHLIST_H

#ifndef	INC_MI32_FILEPATH_H
	#include <mi32/filepath.h>
#endif

#ifndef INC_MI32_MILIST_H
	#include <mi32/milist.h>
#endif


#ifdef MISYSTEMDLL
	#define CLASSLIBEXPORT MI_DLLCLASSEXPORT
#else
	#define CLASSLIBEXPORT MI_DLLCLASSIMPORT
#endif

//! List of FILEPATHs.
class CLASSLIBEXPORT FILEPATHLIST : public MILIST<FILEPATH> {
	public:

		//!< Read FILEPATHLIST from Ini file.
		void IniRead (
			void *IniHandle,
			const char *IniGroup,
			const char *IniName,
			bool CheckIfExist					//!< Check if items exist, may be slow if dismounted locations are in list
			);

		//! Write FILEPATHLIST to Ini file.
		void IniWrite (
			void *IniHandle,
			const char *IniGroup,
			const char *IniName
			) const;
	};

#undef	CLASSLIBEXPORT
#endif	// INC_MI32_FILEPATHLIST_H
