/**
 * \file mi32/modbc.h
 *
 * \if NODOC
 * $Id: modbc.h_v 1.5 2007/10/17 21:44:42 scowan Exp $
 *
 * $Log: modbc.h_v $
 * Revision 1.5  2007/10/17 21:44:42  scowan
 * Removed unused functions.
 *
 * Revision 1.4  2007/04/06 20:57:14  dwilliss
 * forward declare mistringlist too
 *
 * Revision 1.3  2007/04/06 20:35:44  dwilliss
 * forward declare mistring
 *
 * Revision 1.2  2007/04/05 19:43:04  dwilliss
 * get rid of unused include file
 *
 * Revision 1.1  2007/04/05 19:37:08  dwilliss
 * Initial revision
 *
 * \endif
 */

#ifndef INC_MI32_MODBC_H
#define INC_MI32_MODBC_H

#ifndef INC_MI32_STDDEFNS_H
#include <mi32/stddefns.h>	
#endif


#ifdef RVCSYSDLL
	#define RVCSYSLIBEXPORT MI_DLLEXPORT
#else
	#define RVCSYSLIBEXPORT MI_DLLIMPORT
#endif

class MISTRING;
class MISTRINGLIST;

#if defined(WIN32)
#define ODBC 1		//  For checking if we have ODBC at all 
#endif

#if (defined(X_NATIVE) || defined(WIN32_MFC))

//! Select ODBC source.
int ModbcSelectSource (
	MDLGPARENT dlgparent,
	char *title,
	MISTRING& RetName
	);

//! Username / password dialog.
int ModbcUsernamePasswordDialogOld (
	MDLGPARENT dlgparent,
	MIUNICODE *srcname,
	int maxlen,
	int *pKeep,
	int *pTimeoutInterval,
	UINT32 flags
	);

//! Username / password dialog.
int ModbcUsernamePasswordDialog (
	MDLGPARENT dlgparent,
	MISTRING& srcname,
	bool *pKeep,
	int *pTimeoutInterval
	);

#endif	//!< X_NATIVE || WIN32_MFC


extern "C" {
//	The following prototypes are for ODBC support

//! 
RVCSYSLIBEXPORT void ModbcFreeStringList (
	MIUNICODE **NameList
	);

//! 
RVCSYSLIBEXPORT MIUNICODE *ModbcExtractConnectPart (
	const MIUNICODE*,
	char*
	);

//! 
RVCSYSLIBEXPORT int ModbcGetDataSourceList (
	MIUNICODE ***pNameList,
	MIUNICODE ***pDescList
	);

//! 
RVCSYSLIBEXPORT int ModbcGetDriverList (MIUNICODE ***pNameList, 
	MIUNICODE ***pDescList
	);

//! 
RVCSYSLIBEXPORT int ModbcGetHENV (
	void **phenv
	);	/* Really an (HENV*) but don't include odbc crud here */

//! 
RVCSYSLIBEXPORT int _ModbcGetLastError (
								void* hdbc,
								void* hstmt,
								char *rcsid,			//!< For BuildErrStr
								int linenum				//!< For BuildErrStr
								);

}	// extern C

RVCSYSLIBEXPORT void ModbcExtractConnectPart (
	const MISTRING& fname, 
	const char *part,
	MISTRING& retstr
	);
	
RVCSYSLIBEXPORT ERRVALUE ModbcGetDataSourceList (
	MISTRINGLIST& NameList,
	MISTRINGLIST& DescList
	);
	
RVCSYSLIBEXPORT ERRVALUE ModbcGetDriverList (
	MISTRINGLIST& NameList,
	MISTRINGLIST& DescList
	);
	
RVCSYSLIBEXPORT ERRVALUE ModbcGetENV (
	void*& ps_henv
	);
	
RVCSYSLIBEXPORT int ModbcGetLastError (
						int HandleType,		  //!< SQL_HANDLE_ENV, SQL_HANDLE_DBC, SQL_HANDLE_STMT, SQL_HANDLE_DESC 
						void* handle,
						char *rcsid,			//!< For BuildErrStr
						int linenum,			//!< For BuildErrStr
						const MIUNICODE* QueryString = 0
						);


#endif	// INC_MI32_MODBC_H 

